<!DOCTYPE html>
<html>
    <head>
        <title>
            Creación de Páginas Web Nivel 2
        </title>
        <link rel="stylesheet" type="text/css" href="css/index_style.css"/>
        <link  rel="stylesheet" href="https://fonts.googleapis.com/css?family=Karla:400,400i,700,700i&ampdisplay=swap">
    </head>
    <body>
        <div id="whole">
            <div id="upper">
                <h1>
                    CREACIÓN DE PÁGINAS WEB NIVEL 2
                </h1>
            </div>
            <div id="middle">
                <div id="lateral">
                    <center>
                        <h5>
                            TABLA DE CONTENIDO
                        </h5> 
                    </center>
                    <ul>
                        <li>
                            <a href="#javascript">
                                Javascript
                            </a>
                        </li>
                        <li>
                            <a href="#variables">
                                Variables
                            </a>
                        </li>
                        <li>
                            <a href="#arrays">
                                Arrays
                            </a>
                        </li>
                        <li>
                            <a href="#estructuras">
                                Estructuras de Control
                            </a>
                        </li>
                    </ul>
                </div>
                <div id="main">
                    <h2>
                        SESIÓN 2: VARIABLES, ARRAYS Y ESTRUCTURAS DE CONTROL
                    </h2>
                    
                    <h3 id="javascript">
                        Javascript
                    </h3>
                        <p align="justify">
                        	<b>JavaScript</b> es un lenguaje de programación interpretado, dialecto del estándar <i>ECMAScript</i>. Se define como orientado a objetos, basado en prototipos, imperativo, débilmente tipado y dinámico.
                        <p align="justify">
                        	Se utiliza principalmente en su forma del lado del cliente (client-side), implementado como parte de un navegador web permitiendo mejoras en la interfaz de usuario y páginas web dinámicas aunque existe una forma de JavaScript del lado del servidor (Server-side JavaScript o SSJS). Su uso en aplicaciones externas a la web, por ejemplo en documentos PDF, aplicaciones de escritorio (mayoritariamente widgets) es también significativo.
                        <p align="justify">
                        	Desde el 2012, todos los navegadores modernos soportan completamente ECMAScript 5.1, una versión de javascript. Los navegadores más antiguos soportan por lo menos ECMAScript 3. La sexta edición se liberó en julio del 2015.
                        <p align="justify">
                        	JavaScript se diseñó con una sintaxis similar a C, aunque adopta nombres y convenciones del lenguaje de programación Java. Sin embargo, Java y JavaScript tienen semánticas y propósitos diferentes.
                        <p align="justify">
                        	Todos los navegadores modernos interpretan el código JavaScript integrado en las páginas web. Para interactuar con una página web se provee al lenguaje JavaScript de una implementación del Document Object Model (DOM).
                    <h3 id="variables">
                        Variables
                    </h3>
                    <p align="justify">
                        Las variables en los lenguajes de programación siguen una lógica similar a las variables utilizadas en otros ámbitos como las matemáticas. Una variable es un elemento que se emplea para almacenar y hacer referencia a otro valor. Gracias a las variables es posible crear "programas genéricos", es decir, programas que funcionan siempre igual independientemente de los valores concretos utilizados.
                    <p align="justify">
                        De la misma forma que si en Matemáticas no existieran las variables no se podrían definir las ecuaciones y fórmulas, en programación no se podrían hacer programas realmente útiles sin las variables.
                    <p align="justify">
                        Si no existieran variables, un programa que suma dos números podría escribirse como:
                    <p>
                        resultado = 3 + 1

                    <p align="justify">
                        El programa anterior es tan poco útil que sólo sirve para el caso en el que el primer número de la suma sea el 3 y el segundo número sea el 1. En cualquier otro caso, el programa obtiene un resultado incorrecto.
                    <p align="justify">
                        Sin embargo, el programa se puede rehacer de la siguiente manera utilizando variables para almacenar y referirse a cada número:
                    <p>
                        numero_1 = 3<br>
                        numero_2 = 1<br>
                        resultado = numero_1 + numero_2
                    <p align="justify">
                        Los elementos numero_1 y numero_2 son variables que almacenan los valores que utiliza el programa. El resultado se calcula siempre en función del valor almacenado por las variables, por lo que este programa funciona correctamente para cualquier par de números indicado. Si se modifica el valor de las variables numero_1 y numero_2, el programa sigue funcionando correctamente.
                    <p align="justify">
                        Las variables en JavaScript se crean mediante la palabra reservada var. De esta forma, el ejemplo anterior se puede realizar en JavaScript de la siguiente manera:
                    <p>
                        var numero_1 = 3;<br>
                        var numero_2 = 1;<br>
                        var resultado = numero_1 + numero_2;
                    <h3 id="arrays">
                        Arrays
                    </h3>
                    <p align="justify">
                        En ocasiones, a los arrays se les llama vectores, matrices e incluso arreglos. No obstante, el término array es el más utilizado y es una palabra comúnmente aceptada en el entorno de la programación.
                    <p align="justify">
                        Un array es una colección de variables, que pueden ser todas del mismo tipo o cada una de un tipo diferente. Su utilidad se comprende mejor con un ejemplo sencillo: si una aplicación necesita manejar los días de la semana, se podrían crear siete variables de tipo texto:
                    <p>
                        var dia1 = "Lunes";<br>
                        var dia2 = "Martes";<br>
                        ...<br>
                        var dia7 = "Domingo";
                    <p align="justify">
                        Aunque el código anterior no es incorrecto, sí que es poco eficiente y complica en exceso la programación. Si en vez de los días de la semana se tuviera que guardar el nombre de los meses del año, el nombre de todos los países del mundo o las mediciones diarias de temperatura de los últimos 100 años, se tendrían que crear decenas o cientos de variables.
                    <p align="justify">
                        En este tipo de casos, se pueden agrupar todas las variables relacionadas en una colección de variables o array. El ejemplo anterior se puede rehacer de la siguiente forma:
                    <p>
                        var dias = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo"];
                    <p align="justify">
                        Ahora, una única variable llamada dias almacena todos los valores relacionados entre sí, en este caso los días de la semana. Para definir un array, se utilizan los caracteres [ y ] para delimitar su comienzo y su final y se utiliza el carácter , (coma) para separar sus elementos:
                    <p>
                        var nombre_array = [valor1, valor2, ..., valorN];
                    <p align="justify">
                        Una vez definido un array, es muy sencillo acceder a cada uno de sus elementos. Cada elemento se accede indicando su posición dentro del array. La única complicación, que es responsable de muchos errores cuando se empieza a programar, es que las posiciones de los elementos empiezan a contarse en el 0 y no en el 1:
                    <p>
                        var diaSeleccionado = dias[0];    // diaSeleccionado = "Lunes"<br>
                        var otroDia = dias[5];            // otroDia = "Sábado"
                    <p align="justify">
                        En el ejemplo anterior, la primera instrucción quiere obtener el primer elemento del array. Para ello, se indica el nombre del array y entre corchetes la posición del elemento dentro del array. Como se ha comentado, las posiciones se empiezan a contar en el 0, por lo que el primer elemento ocupa la posición 0 y se accede a el mediante dias[0].
                    <p align="justify">
                        El valor dias[5] hace referencia al elemento que ocupa la sexta posición dentro del array dias. Como las posiciones empiezan a contarse en 0, la posición 5 hace referencia al sexto elemento, en este caso, el valor Sábado.
                    <h3 id="estructuras">
                        Estructuras de Control
                    </h3>
                    <p align="justify">
                      Los programas que se pueden realizar utilizando solamente variables y operadores son una simple sucesión lineal de instrucciones básicas.
                    <p align="justify">
                      Sin embargo, no se pueden realizar programas que muestren un mensaje si el valor de una variable es igual a un valor determinado y no muestren el mensaje en el resto de casos. Tampoco se puede repetir de forma eficiente una misma instrucción, como por ejemplo sumar un determinado valor a todos los elementos de un array.
                    <p align="justify">
                      Para realizar este tipo de programas son necesarias las estructuras de control de flujo, que son instrucciones del tipo "si se cumple esta condición, hazlo; si no se cumple, haz esto otro". También existen instrucciones del tipo "repite esto mientras se cumpla esta condición".
                    <p align="justify">
                      Si se utilizan estructuras de control de flujo, los programas dejan de ser una sucesión lineal de instrucciones para convertirse en programas inteligentes que pueden tomar decisiones en función del valor de las variables.
                    <p>
                      <ul>
                        <li>Estructura if</li>
                        <li>Estructura if else</li>
                        <li>Estructura for</li>
                        <li>for in</li>
                        <li>foreach</li>
                        <li>while</li>
                        <li>do while</li>
                      </ul>
                </div>
            </div>
            <div id="footer">
                Página creada por Víctor Alfonso Mantilla Villamizar. 2019<br>Correo electrónico: vmantillav@gmail.com
            </div>
        </div>
    </body>
</html>
